#define OP_ALU 0x0

#define FNCT_ADD 0x0
#define FNCT_SUB 0x4
#define FNCT_MUL 0x8
#define FNCT_DIV 0x10
#define FNCT_SLL 0x18
#define FNCT_SRL 0x1C
#define FNCT_SRR 0x1D
#define FNCT_AND 0x20
#define FNCT_OR  0x24
#define FNCT_XOR 0x28
#define FNCT_NOT 0x2C

#define OP_ADDI 0x18
#define OP_SUBI 0x19
#define OP_MULI 0x1A
#define OP_DIVI 0x1C
#define OP_ANDI 0x1D
#define OP_ORI 	0x1E
#define OP_XORI 0x1F

#define OP_FPU 0x1

#define FNCT_FADD  0x0
#define FNCT_FSUB  0x1
#define FNCT_FMUL  0x2
#define FNCT_FDIV  0x4
#define FNCT_ITOF  0x8
#define FNCT_FTOI  0x9
#define FNCT_FABS  0x3
#define FNCT_FNEG  0x6
#define FNCT_FLOOR 0x1C
#define FNCT_FSQRT 0x1E

#define OP_SYS 0x2

#define FNCT_NOP 0x0
#define FNCT_HLT 0x2
#define FNCT_RD 0x4
#define FNCT_WR 0x5

#define OP_LOAD  0x10
#define OP_STORE 0x12

#define OP_JUMP 0x4
#define OP_JAL  0x5
#define OP_JR   0x8

#define OP_BL   0x21
#define OP_BE   0x22
#define OP_BLE  0x23
#define OP_BGE  0x25
#define OP_BNE  0x26
#define OP_BG   0x27
#define OP_BLZ  0x29
#define OP_BEZ  0x2A
#define OP_BLEZ 0x2B
#define OP_BGEZ 0x2D
#define OP_BNEZ 0x2E
#define OP_BGZ  0x2F

#define OP_FBL   0x31
#define OP_FBE   0x32
#define OP_FBLE  0x33
#define OP_FBGE  0x35
#define OP_FBNE  0x36
#define OP_FBG   0x37
#define OP_FBLZ  0x39
#define OP_FBEZ  0x3A
#define OP_FBLEZ 0x3B
#define OP_FBGEZ 0x3D
#define OP_FBNEZ 0x3E
#define OP_FBGZ  0x3F
