min_caml_mul:
	mul r3 r3 r4
	jr r31
min_caml_div:
	div r3 r3 r4
	jr r31

min_caml_fequal:
	fbe r3 r4 3
	addi r3 r0 0
	jr r31
	addi r3 r0 1
	jr r31
min_caml_fless:
	fbl r3 r4 3
	addi r3 r0 0
	jr r31
	addi r3 r0 1
	jr r31

min_caml_fispos:
	fbl r0 r3 3
	addi r3 r0 1
	jr r31
	addi r3 r0 0
	jr r31
min_caml_fisneg:
	fbl r3 r0 3
	addi r3 r0 0
	jr r31
	addi r3 r0 1
	jr r31
min_caml_fiszero:
	fbne r3 r0 3
	addi r3 r0 1
	jr r31
	addi r3 r0 0
	jr r31

min_caml_xor:
	xor r3 r3
	jr r31
min_caml_not:
	not r3 r3
	jr r31

min_caml_fabs:
	fabs r3 r3
	jr r31
min_caml_fneg:
	fneg r3 r3
	jr r31
min_caml_sqrt:
	fsqrt r3 r3
	jr r31
min_caml_floor:
	floor r3 r3
	jr r31

min_caml_fsqr:
	fmul r3 r3 r3
	jr r31
min_caml_fhalf:
	addi r4 r0 0x3F00
	sll r4 r4 16
	addi r4 r0 0x0000
	fmul r3 r3 r4
	jr r31

min_caml_float_of_int:
	itof r3 r3
	jr r31
min_caml_int_of_float:
	ftoi r3 r3
	jr r31

min_caml_cos:
	cos r3 r3
	jr r31
min_caml_sin:
	sin r3 r3
	jr r31
min_caml_atan:
	atan r3 r3
	jr r31

min_caml_read_float:
	frd r3
	jr r31
min_caml_read_int:
	rd r3
	jr r31

min_caml_create_array:
min_caml_create_float_array:
	addi r5 r30 0
	bl r0 r3 3
	addi r3 r5 0
	jr r31
	store r4 r30 0
	addi r30 r30 1
	subi r3 r3 1
	jump -6

min_caml_print_char:
min_caml_print_int:
	wr r3
